=== src/library/ts/DESCRIPTION ===
Package: ts
Version: 0.1-1
Author: Collected by Brian Ripley. See SOURCES.
Description: Time series functions.
License: GPL Version 2 or later.
